﻿Imports System.Data.OleDb
Imports System.Data
Imports C1.WPF.FlexGrid

Class MainWindow

    Private Sub Window_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs)

        Dim connString As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\ComponentOne Samples\Common\C1NWind.mdb"
        Dim conn As New OleDbConnection(connString)
        Dim comm As New OleDbCommand("Select * from Products", conn)
        Dim adap As New OleDbDataAdapter(comm)
        Dim ds As New DataSet()
        adap.Fill(ds)
        c1FlexGrid1.ItemsSource = ds.Tables(0).AsDataView()

        c1FlexGrid1.AllowMerging = C1.WPF.FlexGrid.AllowMerging.Cells
        Dim mmg As New MyMergeManager()
        c1FlexGrid1.MergeManager = mmg

        Dim mcf As New myCellfactory()
        c1FlexGrid1.CellFactory = mcf

        Dim cs As New C1.WPF.FlexGrid.CellStyle()
        cs.HorizontalAlignment = HorizontalAlignment.Center
        cs.VerticalAlignment = VerticalAlignment.Center

        Me.c1FlexGrid1.Columns("SupplierId").CellStyle = cs
        Me.c1FlexGrid1.Columns("UnitsOnOrder").CellStyle = cs
        Me.c1FlexGrid1.Columns("ReorderLevel").CellStyle = cs
    End Sub
End Class
Public Class MyMergeManager
    Implements IMergeManager
    Public Function GetMergedRange(grid As C1FlexGrid, cellType__1 As CellType, rg As CellRange) As CellRange Implements IMergeManager.GetMergedRange
        ' we are only interested in data cells
        ' (not merging row or column headers)
        If cellType__1 = CellType.Cell Then
            ' expand up/down

            For i As Integer = rg.Row To grid.Rows.Count - 2
                If GetDataDisplay(grid, i, rg.Column) <> GetDataDisplay(grid, i + 1, rg.Column) Then
                    Exit For
                End If
                rg.Row2 = i + 1
            Next
            For i As Integer = rg.Row To 1 Step -1
                If GetDataDisplay(grid, i, rg.Column) <> GetDataDisplay(grid, i - 1, rg.Column) Then
                    Exit For
                End If
                rg.Row = i - 1
            Next
        End If
        Return rg
    End Function
    Private Function GetDataDisplay(grid As C1FlexGrid, r As Integer, c As Integer) As String
        Return grid(r, c).ToString()
    End Function
End Class
Public Class myCellfactory
    Inherits CellFactory
    Public Overrides Sub CreateCellContent(grid As C1FlexGrid, bdr As Border, rng As CellRange)
        MyBase.CreateCellContent(grid, bdr, rng)
        Dim tb = TryCast(bdr.Child, TextBlock)

        If tb IsNot Nothing AndAlso rng.Column = 2 OrElse rng.Column = 7 OrElse rng.Column = 8 Then
            Dim cp As ContentPresenter = TryCast(VisualTreeHelper.GetParent(tb), ContentPresenter)
            Dim rotateTransform As System.Windows.Media.RotateTransform = New RotateTransform()
            rotateTransform.Angle = 50
            tb.LayoutTransform = rotateTransform
            bdr.Background = Brushes.PaleGreen
            tb.Foreground = Brushes.Blue
        End If
    End Sub
End Class
